## openssh 9.8p1

=== debian/changelog ===
openssh (1:9.8p1-8.0nosystemd1) nosystemd; urgency=medium

  * No systemd/elogind 

 -- anticapitalista <antix@operamail.com>  Fri, 30 Aug 2024 17:58:14 +0300

openssh (1:9.8p1-8) unstable; urgency=medium

  * Source-only reupload.

 -- Colin Watson <cjwatson@debian.org>  Fri, 30 Aug 2024 00:38:26 +0100

openssh (1:9.8p1-7) unstable; urgency=medium

  * Adjust description line-wrapping so that lintian recognizes that
    openssh-client-gssapi is an intentionally empty package.

 -- Colin Watson <cjwatson@debian.org>  Thu, 29 Aug 2024 14:17:13 +0100

openssh (1:9.8p1-6) unstable; urgency=medium

  * Upload with binaries to satisfy Debian archive NEW checks.

 -- Colin Watson <cjwatson@debian.org>  Thu, 29 Aug 2024 13:46:57 +0100

openssh (1:9.8p1-5) unstable; urgency=medium

  * Add openssh-client-gssapi and openssh-server-gssapi packages; these
    currently just depend on their non-gssapi counterparts, but will become
    different in future.  See
    https://lists.debian.org/debian-devel/2024/04/msg00044.html.

 -- Colin Watson <cjwatson@debian.org>  Thu, 29 Aug 2024 12:53:42 +0100

openssh (1:9.8p1-4) unstable; urgency=medium

  [ Grzegorz Szymaszek ]
  * Disable listening on 22 in the port change example in README.Debian.

  [ Colin Watson ]
  * sshd: Allow exec without absolute path in inetd mode (closes: #1078429).
  * Add an autopkgtest for running sshd from xinetd.

 -- Colin Watson <cjwatson@debian.org>  Mon, 26 Aug 2024 15:02:45 +0100

openssh (1:9.8p1-3) unstable; urgency=medium

  [ Dirk Van Haerenborgh ]
  * Add sshd-session to openssh-server-udeb.

 -- Colin Watson <cjwatson@debian.org>  Tue, 06 Aug 2024 12:58:46 +0100

openssh (1:9.8p1-2) unstable; urgency=medium

  * Don't close sockets passed by systemd socket activation (closes:
    #1077765).
  * Add an autopkgtest for socket activation.
  * Consult /etc/hosts.{allow,deny} as "sshd", not "sshd-session" (closes:
    #1077799).

 -- Colin Watson <cjwatson@debian.org>  Fri, 02 Aug 2024 17:08:58 +0100

openssh (1:9.8p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/releasenotes.html#9.8p1):
    - CVE-2024-39894: Fix Logic error in ssh(1) ObscureKeystrokeTiming that
      made the feature ineffective.
    - The DSA signature algorithm is now disabled at compile-time.
    - sshd(8): the server has been split into a listener binary, sshd(8),
      and a per-session binary "sshd-session".  This allows for a much
      smaller listener binary, as it no longer needs to support the SSH
      protocol.  As part of this work, support for disabling privilege
      separation (which previously required code changes to disable) and
      disabling re-execution of sshd(8) has been removed.  Further
      separation of sshd-session into additional, minimal binaries is
      planned for the future.
    - sshd(8): several log messages have changed.  In particular, some log
      messages will be tagged with as originating from a process named
      "sshd-session" rather than "sshd".
    - ssh-keyscan(1): this tool previously emitted comment lines containing
      the hostname and SSH protocol banner to standard error.  This release
      now emits them to standard output, but adds a new "-q" flag to silence
      them altogether.
    - sshd(8): sshd will no longer use argv[0] as the PAM service name.  A
      new "PAMServiceName" sshd_config(5) directive allows selecting the
      service name at runtime.  This defaults to "sshd".
    - sshd(8): penalise client addresses that, for various reasons, do not
      successfully complete authentication.  This feature is controlled by a
      new sshd_config(5) PerSourcePenalties option and is on by default.
    - ssh(8): allow the HostkeyAlgorithms directive to disable the implicit
      fallback from certificate host key to plain host keys.
    - misc: fix a number of inaccuracies in the PROTOCOL.* documentation
      files.
    - all: switch to strtonum(3) for more robust integer parsing in most
      places.
    - ssh(1), sshd(8): correctly restore sigprocmask around ppoll().
    - ssh-keysign(8): stricter validation of messaging socket fd.
    - sftp(1): flush stdout after writing "sftp>" prompt when not using
      editline.
    - sftp-server(8): fix home-directory extension implementation, it
      previously always returned the current user's home directory contrary
      to the spec.
    - ssh-keyscan(1): do not close stdin to prevent error messages when
      stdin is read multiple times.
    - regression tests: fix rekey test that was testing the same KEX
      algorithm repeatedly instead of testing all of them.
    - ssh_config(5), sshd_config(5): clarify the KEXAlgorithms directive
      documentation, especially around what is supported vs available
      (closes: #1073065).
    - sshd(8): expose SSH_AUTH_INFO_0 always to PAM auth modules
      unconditionally. The previous behaviour was to expose it only when
      particular authentication methods were in use.
    - build: fix OpenSSL ED25519 support detection. An incorrect function
      signature in configure.ac previously prevented enabling the recently
      added support for ED25519 private keys in PEM PKCS8 format.
    - ssh(1), ssh-agent(8): allow the presence of the WAYLAND_DISPLAY
      environment variable to enable SSH_ASKPASS, similarly to the X11
      DISPLAY environment variable (closes: #1037515, #1068044).
  * Stop generating DSA host key.
  * Apply X-Style: black.

 -- Colin Watson <cjwatson@debian.org>  Wed, 31 Jul 2024 17:16:04 +0100

openssh (1:9.7p1-7) unstable; urgency=critical

  [ Salvatore Bonaccorso ]
  * Disable async-signal-unsafe code from the sshsigdie() function.  This is
    a minimal workaround for a regression from CVE-2006-5051.

 -- Colin Watson <cjwatson@debian.org>  Mon, 01 Jul 2024 10:11:27 +0100

openssh (1:9.7p1-6) unstable; urgency=medium

  * Stop reading ~/.pam_environment, which has a history of security


=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

include /usr/share/dpkg/default.mk

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  RUN_TESTS := yes
else
  RUN_TESTS :=
endif

ifeq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  PARALLEL :=
else
  PARALLEL := \
	-j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
  CC := gcc
  PKG_CONFIG = pkg-config
else
  CC := $(DEB_HOST_GNU_TYPE)-gcc
  PKG_CONFIG = $(DEB_HOST_GNU_TYPE)-pkg-config
  RUN_TESTS :=
endif

# Change the version string to reflect distribution
SSH_EXTRAVERSION := $(DEB_VENDOR)-$(shell echo '$(DEB_VERSION)' | sed -e 's/.*-//; s/+salsaci+.*/+salsaci/')

UBUNTU := $(shell $(call dpkg_vendor_derives_from,Ubuntu))
ifeq ($(UBUNTU),yes)
DEFAULT_PATH := /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
else
DEFAULT_PATH := /usr/local/bin:/usr/bin:/bin:/usr/games
endif
SUPERUSER_PATH := /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

ifeq ($(UBUNTU),yes)
server_recommends := ssh-import-id
else
server_recommends :=
endif

# Common path configuration.
confflags += --sysconfdir=/etc/ssh
confflags += --libexecdir=\$${prefix}/lib/openssh

# Common build options.
confflags += --disable-strip
confflags += --with-mantype=doc
confflags += --with-4in6
confflags += --with-privsep-path=/run/sshd
confflags += --with-pid-dir=/run

# The Hurd needs libcrypt for res_query et al.
ifeq ($(DEB_HOST_ARCH_OS),hurd)
confflags += --with-libs=-lcrypt
endif

# Always use the internal mkdtemp; see https://bugs.debian.org/1001186.
confflags += ac_cv_func_mkdtemp=no

# ppc64el doesn't support -fzero-call-used-regs=used, but configure fails to
# detect that.
ifeq ($(DEB_HOST_ARCH),ppc64el)
confflags += ossh_cv_cflag__fzero_call_used_regs_used=no
endif

# Everything above here is common to the deb and udeb builds.
confflags_udeb := $(confflags)

# Options specific to the deb build.
confflags += --with-tcp-wrappers
confflags += --with-pam
confflags += --with-libedit
confflags += --with-kerberos5=/usr
confflags += --with-ssl-engine
ifeq ($(DEB_HOST_ARCH_OS),linux)
confflags += --with-selinux
confflags += --with-audit=linux
confflags += --with-security-key-builtin
endif

# The deb build wants xauth; the udeb build doesn't.
confflags += --with-xauth=/usr/bin/xauth
confflags_udeb += --without-xauth

# Default paths. The udeb build has /usr/games removed.
confflags += --with-default-path=$(DEFAULT_PATH) --with-superuser-path=$(SUPERUSER_PATH)
confflags_udeb += --with-default-path=/usr/local/bin:/usr/bin:/bin --with-superuser-path=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

# Compiler flags.
cflags := $(CPPFLAGS) $(CFLAGS)
cflags += -DSSH_EXTRAVERSION=\"$(SSH_EXTRAVERSION)\"
cflags_udeb := -Os
cflags_udeb += -DSSH_EXTRAVERSION=\"$(SSH_EXTRAVERSION)\"
confflags += --with-cflags='$(cflags)'
confflags_udeb += --with-cflags='$(cflags_udeb)'

# Linker flags.
confflags += --with-ldflags='$(strip -Wl,--as-needed $(LDFLAGS))'
confflags_udeb += --with-ldflags='-Wl,--as-needed'

ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes) $(DEB_HOST_ARCH), yes i386)
  BUILD_PACKAGES += -Nopenssh-tests
endif

%:
	dh $@ --with=runit $(BUILD_PACKAGES)

override_dh_autoreconf-indep:

override_dh_auto_configure-arch:
	dh_auto_configure -Bdebian/build-deb -- $(confflags)
ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
	dh_auto_configure -Bdebian/build-udeb -- $(confflags_udeb)
	# Avoid libnsl linkage. Ugh.
	perl -pi -e 's/ +-lnsl//' debian/build-udeb/config.status
	cd debian/build-udeb && ./config.status
endif

override_dh_auto_configure-indep:

override_dh_auto_build-arch:
	$(MAKE) -C debian/build-deb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass'
	$(MAKE) -C debian/build-deb regress-prep
	$(MAKE) -C debian/build-deb $(PARALLEL) regress-binaries regress-unit-binaries
ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
	$(MAKE) -C debian/build-udeb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass' ssh scp sftp sshd ssh-keygen sshd-session
endif

ifeq ($(filter pkg.openssh.nognome,$(DEB_BUILD_PROFILES)),)
	$(MAKE) -C contrib gnome-ssh-askpass3 CC='$(CC) $(CPPFLAGS) $(CFLAGS) -Wall -Wl,--as-needed $(LDFLAGS)' PKG_CONFIG=$(PKG_CONFIG)
endif

override_dh_auto_build-indep:

override_dh_auto_test-arch:
ifeq ($(RUN_TESTS),yes)
	$(MAKE) -C debian/build-deb unit compat-tests
	$(MAKE) -C debian/keygen-test
	debian/check-ucf-md5sums
endif

override_dh_auto_test-indep:

override_dh_auto_clean:
	rm -rf debian/build-deb debian/build-udeb
ifeq ($(RUN_TESTS),yes)
	$(MAKE) -C debian/keygen-test clean
endif
	$(MAKE) -C contrib clean

override_dh_auto_install-arch:
	$(MAKE) -C debian/build-deb DESTDIR=`pwd`/debian/tmp install-nokeys

override_dh_auto_install-indep:

override_dh_install-arch:
	# Remove version control tags to avoid unnecessary conffile
	# resolution steps for administrators.
	sed -i '/\$$OpenBSD:/d' \
		debian/tmp/etc/ssh/moduli \
		debian/tmp/etc/ssh/ssh_config \
		debian/tmp/etc/ssh/sshd_config

	dh_install -Nopenssh-client-udeb -Nopenssh-server-udeb
ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
	dh_install -popenssh-client-udeb -popenssh-server-udeb \
		--sourcedir=debian/build-udeb
endif

	# This can't be done using dh_link, because it's needed earlier by
	# dh_installalternatives.
	ln -sf ssh debian/openssh-client/usr/bin/slogin

	rm -f debian/openssh-tests/usr/lib/openssh/regress/misc/sk-dummy/*.lo

override_dh_installdocs:
	dh_installdocs -Nopenssh-server -Nopenssh-sftp-server
	dh_installdocs -popenssh-server -popenssh-sftp-server \
		--link-doc=openssh-client
	# Avoid breaking dh_installexamples later.
	mkdir -p debian/openssh-server/usr/share/doc/openssh-client

override_dh_installinit:
	dh_installinit -R --name ssh

debian/openssh-server.sshd.pam: debian/openssh-server.sshd.pam.in
ifeq ($(DEB_HOST_ARCH_OS),linux)
	sed 's/^@IF_KEYINIT@//' $< > $@
else
	sed '/^@IF_KEYINIT@/d' $< > $@
endif

override_dh_installpam: debian/openssh-server.sshd.pam
	dh_installpam --name sshd

override_dh_runit:
	dh_runit -popenssh-server

execute_after_dh_fixperms-arch:
	chmod u+s debian/openssh-client/usr/lib/openssh/ssh-keysign

# Work around debhelper/dh-exec bug #1017023.
override_dh_missing:
	dh_missing --list-missing

override_dh_gencontrol:
	dh_gencontrol -- -V'openssh-server:Recommends=$(server_recommends)'

=== debian/tests/control ===
Tests:
 regress,
Restrictions:
 allow-stderr,
 isolation-container,
 needs-root,
Depends:
 devscripts,
 dropbear,
 haveged,
 openssh-tests,
 openssl,
 putty-tools,
 python3-twisted,
 sudo,
 sysvinit-utils,

Tests:
 ssh-gssapi,
Restrictions:
 allow-stderr,
 isolation-container,
 needs-root,
Depends:
 krb5-admin-server,
 krb5-kdc,
 openssh-server-gssapi,

Tests:
 socket-activation,
Restrictions:
 allow-stderr,
 isolation-container,
 needs-root,
Depends:
 openssh-server,
 sudo,

Tests:
 xinetd,
Restrictions:
 allow-stderr,
 isolation-container,
 needs-root,
Depends:
 openssh-server,
 sudo,
 xinetd,

## openssh 9.9p1

=== debian/changelog ===
openssh (1:9.9p1-3ubuntu3) plucky; urgency=medium

  * SECURITY UPDATE: MitM with VerifyHostKeyDNS option
    - debian/patches/CVE-2025-26465.patch: fix error code handling in
      krl.c, ssh-agent.c, ssh-sk-client.c, sshconnect2.c, sshsig.c.
    - CVE-2025-26465
  * SECURITY UPDATE: pre-authentication denial of service
    - debian/patches/CVE-2025-26466.patch: don't reply to PING in preauth
      or in KEX in packet.c.
    - CVE-2025-26466

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 18 Feb 2025 08:50:06 -0500

openssh (1:9.9p1-3ubuntu2) plucky; urgency=medium

  * document /etc/ssh/sshd_config.d/*.conf better in sshd_config
    (LP: #2088207)
    - d/p/debian-config.patch: expand comment about configuration options
      and precedence of configuration snippets
    - d/openssh-server.ucf-md5sum: update for new sshd_config comments
    - d/p/sshd-socket-generator.patch: refresh for sshd_config comment
  * d/t/systemd-socket-activation: add wait while unit is reloading
    This avoids a race condition where we sometimes fail the assertion
    that ActiveState=active after systemctl reload.
    (LP: #2089049)

 -- Nick Rosbrook <enr0n@ubuntu.com>  Tue, 19 Nov 2024 12:06:14 -0500

openssh (1:9.9p1-3ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable (LP: #2085261). Remaining changes:
    - Make systemd socket activation the default:
      + debian/rules: modify dh_installsystemd invocations for
        socket-activated sshd
      + debian/README.Debian: document systemd socket activation.
      + debian/patches/systemd-socket-activation.patch: Fix sshd
        re-execution behavior when socket activation is used
      + debian/tests/systemd-socket-activation: Add autopkgtest for systemd socket
        activation functionality.
      + debian/control: Build-Depends: systemd-dev
      + d/p/sshd-socket-generator.patch: add generator for socket activation
      + debian/openssh-server.install: install sshd-socket-generator
      + debian/openssh-server.postinst: handle migration to sshd-socket-generator
      + d/t/sshd-socket-generator: add dep8 test for sshd-socket-generator
      + ssh.socket: adjust unit for socket activation by default
      + debian/rules: explicitly enable LTO
    - debian/.gitignore: drop file
    - debian/openssh-server.ucf-md5sum: update for Ubuntu delta
    - debian/patches: Immediately report interactive instructions to PAM clients
    - debian/patches: sshconnect2: Write kbd-interactive messages as utf-8
    - d/t/ssh-gssapi: disable -e in cleanup()
  * Dropped changes, included in Debian:
    - SECURITY UPDATE: timing attack against echo-off password entry
      + debian/patches/CVE-2024-39894.patch: don't rely on
        channel_did_enqueue in clientloop.c
      + CVE-2024-39894
  * New changes:
    - d/p/systemd-socket-activation.patch: refresh and adapt for sshd-session
    - d/openssh-server.links: add full sshd.service -> ssh.service alias
      (LP: #2087949)

 -- Nick Rosbrook <enr0n@ubuntu.com>  Tue, 12 Nov 2024 16:28:26 -0500

openssh (1:9.9p1-3) unstable; urgency=medium

  * Fix mlkem768x25519-sha256 key exchange algorithm on big-endian
    architectures.
  * Drop patch to define MAXHOSTNAMELEN on GNU/Hurd (no longer needed).

 -- Colin Watson <cjwatson@debian.org>  Sun, 27 Oct 2024 13:58:04 +0000

openssh (1:9.9p1-2) unstable; urgency=medium

  * Don't prefer host-bound public key signatures if there was no initial
    host key, as is the case when using GSS-API key exchange (closes:
    #1041521).
  * Use runuser rather than sudo in autopkgtests where possible, avoiding a
    dependency.

 -- Colin Watson <cjwatson@debian.org>  Mon, 21 Oct 2024 18:24:07 +0100

openssh (1:9.9p1-1) unstable; urgency=medium

  * Alias the old Debian-specific SetupTimeOut client option to
    ConnectTimeout rather than to ServerAliveInterval.
  * New upstream release (https://www.openssh.com/releasenotes.html#9.9p1):
    - ssh(1): remove support for pre-authentication compression.
    - ssh(1), sshd(8): processing of the arguments to the "Match"
      configuration directive now follows more shell-like rules for quoted
      strings, including allowing nested quotes and \-escaped characters.
    - ssh(1), sshd(8): add support for a new hybrid post-quantum key
      exchange based on the FIPS 203 Module-Lattice Key Enapsulation
      mechanism (ML-KEM) combined with X25519 ECDH as described by
      https://datatracker.ietf.org/doc/html/draft-kampanakis-curdle-ssh-pq-ke-03
      This algorithm "mlkem768x25519-sha256" is available by default.
    - ssh(1): the ssh_config "Include" directive can now expand environment
      as well as the same set of %-tokens "Match Exec" supports.
    - sshd(8): add a sshd_config "RefuseConnection" option that, if set will
      terminate the connection at the first authentication request.
    - sshd(8): add a "refuseconnection" penalty class to sshd_config
      PerSourcePenalties that is applied when a connection is dropped by the
      new RefuseConnection keyword.
    - sshd(8): add a "Match invalid-user" predicate to sshd_config Match
      options that matches when the target username is not valid on the
      server.
    - ssh(1), sshd(8): update the Streamlined NTRUPrime code to a
      substantially faster implementation.
    - ssh(1), sshd(8): the hybrid Streamlined NTRUPrime/X25519 key exchange
      algorithm now has an IANA-assigned name in addition to the
      "@openssh.com" vendor extension name. This algorithm is now also
      available under this name "sntrup761x25519-sha512"
    - ssh(1), sshd(8), ssh-agent(1): prevent private keys from being
      included in core dump files for most of their lifespans. This is in
      addition to pre-existing controls in ssh-agent(1) and sshd(8) that
      prevented coredumps.
    - All: convert key handling to use the libcrypto EVP_PKEY API, with the
      exception of DSA.
    - sshd(8): add a random amount of jitter (up to 4 seconds) to the grace


=== debian/control ===
Source: openssh
Section: net
Priority: standard
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OpenSSH Maintainers <debian-ssh@lists.debian.org>
Build-Depends:
 debhelper (>= 13.1~),
 debhelper-compat (= 13),
 dh-exec,
 dh-runit (>= 2.8.8),
 dh-sequence-movetousr,
 libaudit-dev [linux-any],
 libedit-dev,
 libfido2-dev (>= 1.5.0) [linux-any],
 libgtk-3-dev <!pkg.openssh.nognome>,
 libkrb5-dev | heimdal-dev,
 libpam0g-dev | libpam-dev,
 libselinux1-dev [linux-any],
 libssl-dev (>= 1.1.1),
 libwrap0-dev | libwrap-dev,
 pkgconf,
 zlib1g-dev,
 systemd-dev,
Standards-Version: 4.6.2
Uploaders:
 Colin Watson <cjwatson@debian.org>,
 Matthew Vernon <matthew@debian.org>,
Homepage: https://www.openssh.com/
Vcs-Git: https://salsa.debian.org/ssh-team/openssh.git
Vcs-Browser: https://salsa.debian.org/ssh-team/openssh
Rules-Requires-Root: no
X-Style: black

Package: openssh-client
Architecture: any
Depends:
 adduser,
 passwd,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 xauth,
Conflicts:
 sftp,
Breaks:
 openssh-sk-helper,
Replaces:
 openssh-sk-helper,
 ssh,
 ssh-krb5,
Suggests:
 keychain,
 libpam-ssh,
 monkeysphere,
 ssh-askpass,
Provides:
 ssh-client,
Multi-Arch: foreign
Description: secure shell (SSH) client, for secure access to remote machines
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides the ssh, scp and sftp clients, the ssh-agent
 and ssh-add programs to make public key authentication more convenient,
 and the ssh-keygen, ssh-keyscan, ssh-copy-id and ssh-argv0 utilities.
 .
 In some countries it may be illegal to use any encryption at all
 without a special permit.
 .
 ssh replaces the insecure rsh, rcp and rlogin programs, which are
 obsolete for most purposes.

Package: openssh-client-gssapi
Priority: optional
Architecture: all
Depends:
 openssh-client (>= ${binary:Version}),
 ${misc:Depends},
Multi-Arch: foreign
Description: secure shell (SSH) client, with GSS-API support
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides versions of the ssh client and related programs
 built with support for GSS-API authentication and key exchange, which
 can be used with systems such as Kerberos.
 It is currently an empty package depending on openssh-client, but
 future releases will remove GSS-API support from openssh-client, so
 users who need it should install this package.

Package: openssh-server
Priority: optional
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 adduser,
 libpam-modules,
 libpam-runtime,
 lsb-base,
 openssh-client (= ${binary:Version}),
 openssh-sftp-server,
 procps,
 ucf,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 default-logind | logind | libpam-systemd,
 ncurses-term,
 xauth,
 ${openssh-server:Recommends},
Conflicts:
 sftp,
 ssh-socks,
 ssh2,
Replaces:
 openssh-client (<< 1:7.9p1-8),
 ssh,
 ssh-krb5,
Breaks:
 ${runit:Breaks},
Suggests:
 molly-guard,
 monkeysphere,
 ssh-askpass,
 ufw,
Provides:
 ssh-server,
Multi-Arch: foreign
Description: secure shell (SSH) server, for secure access from remote machines
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides the sshd server.
 .
 In some countries it may be illegal to use any encryption at all
 without a special permit.
 .
 sshd replaces the insecure rshd program, which is obsolete for most
 purposes.

Package: openssh-server-gssapi
Priority: optional
Architecture: all
Depends:
 openssh-client-gssapi (>= ${binary:Version}),
 openssh-server (>= ${binary:Version}),
 ${misc:Depends},
Multi-Arch: foreign
Description: secure shell (SSH) server, with GSS-API key exchange
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides a version of the sshd server built with support
 for GSS-API authentication and key exchange, which can be used with
 systems such as Kerberos.
 It is currently an empty package depending on openssh-server, but
 future releases will remove GSS-API support from openssh-server, so
 users who need it should install this package.

Package: openssh-sftp-server
Priority: optional
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 openssh-server | ssh-server,
Breaks:
 openssh-server (<< 1:6.5p1-5),
Replaces:
 openssh-server (<< 1:6.5p1-5),
Enhances:
 openssh-server,
 ssh-server,
Multi-Arch: foreign
Description: secure shell (SSH) sftp server module, for SFTP access from remote machines
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides the SFTP server module for the SSH server. It
 is needed if you want to access your SSH server with SFTP. The SFTP
 server module also works with other SSH daemons like dropbear.
 .
 OpenSSH's sftp and sftp-server implement revision 3 of the SSH filexfer
 protocol described in:
 .
  http://www.openssh.com/txt/draft-ietf-secsh-filexfer-02.txt
 .
 Newer versions of the draft will not be supported, though some features
 are individually implemented as extensions.

Package: openssh-tests
Priority: optional
Architecture: any
Depends:
 openssh-client (= ${binary:Version}),
 openssh-server (= ${binary:Version}),
 openssh-sftp-server (= ${binary:Version}),
 openssl,
 putty-tools (>= 0.67-2),
 python3-twisted,
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: foreign
Description: OpenSSH regression tests
 This package provides OpenSSH's regression test suite.  It is mainly
 intended for use with the autopkgtest system, though can also be run
 directly using /usr/lib/openssh/regress/run-tests.

Package: ssh
Priority: optional
Architecture: all
Depends:
 openssh-client (>= ${binary:Version}),
 openssh-server (>= ${binary:Version}),
 ${misc:Depends},
Multi-Arch: foreign
Description: secure shell client and server (metapackage)
 This metapackage is a convenient way to install both the OpenSSH client
 and the OpenSSH server. It provides nothing in and of itself, so you
 may remove it if nothing depends on it.

Package: ssh-askpass-gnome
Build-Profiles: <!pkg.openssh.nognome>
Section: gnome
Priority: optional
Architecture: any
Depends:
 openssh-client | ssh (>= 1:1.2pre7-4),
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 ssh (<< 1:3.5p1-3),
Provides:
 ssh-askpass,
Multi-Arch: foreign
Description: interactive X program to prompt users for a passphrase for ssh-add
 This has been split out of the main openssh-client package so that
 openssh-client does not need to depend on GTK+.
 .
 You probably want the ssh-askpass package instead, but this is
 provided to add to your choice and/or confusion.

Package: openssh-client-udeb
Build-Profiles: <!noudeb>
Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
XB-Installer-Menu-Item: 99999
Description: secure shell client for the Debian installer
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 This package provides the ssh client for use in debian-installer.

Package: openssh-server-udeb
Build-Profiles: <!noudeb>
Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: secure shell server for the Debian installer
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 This package provides the sshd server for use in debian-installer.
 Since it is expected to be used in specialized situations (e.g. S/390
 installs with no console), it does not provide any configuration.

=== debian/tests/control ===
--- 
+++ 
@@ -34,7 +34,6 @@
  needs-root,
 Depends:
  openssh-server,
- sudo,
 
 Tests:
  xinetd,
@@ -44,5 +43,16 @@
  needs-root,
 Depends:
  openssh-server,
- sudo,
  xinetd,
+
+Tests: systemd-socket-activation
+Restrictions: needs-root allow-stderr
+Depends: openssh-client,
+         openssh-server,
+         systemd,
+
+Tests: sshd-socket-generator
+Restrictions: needs-root allow-stderr
+Depends: openssh-client,
+         openssh-server,
+         systemd,

## openssh 9.9p2

=== debian/changelog ===
openssh (1:9.9p2-0deepin1) unstable; urgency=medium

  * Update to 9.9p2, fixes CVE-2025-26465, CVE-2025-26466
  * Refresh patches (mlkem768x25519-big-endian-{1,2}.patch)

 -- Tianyu Chen <sweetyfish@deepin.org>  Tue, 18 Feb 2025 18:13:26 +0800

openssh (1:9.9p1-3deepin2) unstable; urgency=medium

  [ liujianqiang ]
  * ssh.service is disabled by default.
  * update ChannelTimeout config to implement auto close inactive
    connections.

 -- Tianyu Chen <sweetyfish@deepin.org>  Wed, 15 Jan 2025 14:50:47 +0800

openssh (1:9.9p1-3deepin1) unstable; urgency=medium

  * Refresh and re-apply deepin patches:
    deepin-extra-version.patch
    deepin-ssh-connect-idle-timeout.patch
    deepin-ssh-keygen-privatekey-file-perm.patch
  * Update openssh-server.ucf-md5sum.

 -- Tianyu Chen <sweetyfish@deepin.org>  Wed, 15 Jan 2025 14:42:25 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: openssh
 Section: net
 Priority: standard
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OpenSSH Maintainers <debian-ssh@lists.debian.org>
+Maintainer: Debian OpenSSH Maintainers <debian-ssh@lists.debian.org>
 Build-Depends:
  debhelper (>= 13.1~),
  debhelper-compat (= 13),
@@ -20,7 +19,7 @@
  libwrap0-dev | libwrap-dev,
  pkgconf,
  zlib1g-dev,
- systemd-dev,
+ lsb-release,
 Standards-Version: 4.6.2
 Uploaders:
  Colin Watson <cjwatson@debian.org>,

=== debian/rules ===
--- 
+++ 
@@ -194,6 +194,15 @@
 override_dh_installinit:
 	dh_installinit -R --name ssh
 
+override_dh_installsystemd:
+ifeq ($(shell lsb_release  -i -s),uos)
+	dh_installsystemd -popenssh-server --no-enable ssh.service
+else
+	dh_installsystemd -popenssh-server ssh.service
+endif
+	dh_installsystemd -popenssh-server --no-enable ssh.socket
+	dh_installsystemd -popenssh-server --no-start rescue-ssh.target
+
 debian/openssh-server.sshd.pam: debian/openssh-server.sshd.pam.in
 ifeq ($(DEB_HOST_ARCH_OS),linux)
 	sed 's/^@IF_KEYINIT@//' $< > $@

=== debian/tests/control ===
--- 
+++ 
@@ -44,15 +44,3 @@
 Depends:
  openssh-server,
  xinetd,
-
-Tests: systemd-socket-activation
-Restrictions: needs-root allow-stderr
-Depends: openssh-client,
-         openssh-server,
-         systemd,
-
-Tests: sshd-socket-generator
-Restrictions: needs-root allow-stderr
-Depends: openssh-client,
-         openssh-server,
-         systemd,

## openssh 10.0p1

=== contrib/cygwin/Makefile ===
srcdir=../..
copyidsrcdir=..
prefix=/usr
exec_prefix=$(prefix)
bindir=$(prefix)/bin
datadir=$(prefix)/share
mandir=$(datadir)/man
docdir=$(datadir)/doc
sshdocdir=$(docdir)/openssh
cygdocdir=$(docdir)/Cygwin
sysconfdir=/etc
defaultsdir=$(sysconfdir)/defaults/etc
inetdefdir=$(defaultsdir)/inetd.d
PRIVSEP_PATH=/var/empty
INSTALL=/usr/bin/install -c
MKDIR_P=$(srcdir)/mkinstalldirs

DESTDIR=

all:
	@echo
	@echo "Use \`make cygwin-postinstall DESTDIR=[package directory]'"
	@echo "Be sure having DESTDIR set correctly!"
	@echo

move-config-files: $(DESTDIR)$(sysconfdir)/ssh_config $(DESTDIR)$(sysconfdir)/sshd_config
	$(MKDIR_P) $(DESTDIR)$(defaultsdir)
	mv $(DESTDIR)$(sysconfdir)/ssh_config $(DESTDIR)$(defaultsdir)
	mv $(DESTDIR)$(sysconfdir)/sshd_config $(DESTDIR)$(defaultsdir)

remove-empty-dir:
	rm -rf $(DESTDIR)$(PRIVSEP_PATH)

install-inetd-config:
	$(MKDIR_P) $(DESTDIR)$(inetdefdir)
	$(INSTALL) -m 644 sshd-inetd  $(DESTDIR)$(inetdefdir)/sshd-inetd

install-sshdoc:
	$(MKDIR_P) $(DESTDIR)$(sshdocdir)
	-$(INSTALL) -m 644 $(srcdir)/CREDITS $(DESTDIR)$(sshdocdir)/CREDITS
	-$(INSTALL) -m 644 $(srcdir)/ChangeLog $(DESTDIR)$(sshdocdir)/ChangeLog
	-$(INSTALL) -m 644 $(srcdir)/LICENCE $(DESTDIR)$(sshdocdir)/LICENCE
	-$(INSTALL) -m 644 $(srcdir)/OVERVIEW $(DESTDIR)$(sshdocdir)/OVERVIEW
	-$(INSTALL) -m 644 $(srcdir)/PROTOCOL $(DESTDIR)$(sshdocdir)/PROTOCOL
	-$(INSTALL) -m 644 $(srcdir)/PROTOCOL.agent $(DESTDIR)$(sshdocdir)/PROTOCOL.agent
	-$(INSTALL) -m 644 $(srcdir)/PROTOCOL.certkeys $(DESTDIR)$(sshdocdir)/PROTOCOL.certkeys
	-$(INSTALL) -m 644 $(srcdir)/PROTOCOL.mux $(DESTDIR)$(sshdocdir)/PROTOCOL.mux
	-$(INSTALL) -m 644 $(srcdir)/README $(DESTDIR)$(sshdocdir)/README
	-$(INSTALL) -m 644 $(srcdir)/README.dns $(DESTDIR)$(sshdocdir)/README.dns
	-$(INSTALL) -m 644 $(srcdir)/README.platform $(DESTDIR)$(sshdocdir)/README.platform
	-$(INSTALL) -m 644 $(srcdir)/README.privsep $(DESTDIR)$(sshdocdir)/README.privsep
	-$(INSTALL) -m 644 $(srcdir)/README.tun $(DESTDIR)$(sshdocdir)/README.tun
	-$(INSTALL) -m 644 $(srcdir)/TODO $(DESTDIR)$(sshdocdir)/TODO

install-cygwindoc: README
	$(MKDIR_P) $(DESTDIR)$(cygdocdir)
	$(INSTALL) -m 644 README $(DESTDIR)$(cygdocdir)/openssh.README

install-doc: install-sshdoc install-cygwindoc

install-scripts: ssh-host-config ssh-user-config
	$(MKDIR_P) $(DESTDIR)$(bindir)
	$(INSTALL) -m 755 ssh-host-config $(DESTDIR)$(bindir)/ssh-host-config
	$(INSTALL) -m 755 ssh-user-config $(DESTDIR)$(bindir)/ssh-user-config

install-copy-id: $(copyidsrcdir)/ssh-copy-id $(copyidsrcdir)/ssh-copy-id.1
	$(INSTALL) -m 755 $(copyidsrcdir)/ssh-copy-id $(DESTDIR)$(bindir)/ssh-copy-id
	$(INSTALL) -m 644 $(copyidsrcdir)/ssh-copy-id.1 $(DESTDIR)$(mandir)/man1/ssh-copy-id.1

gzip-man-pages:
	rm $(DESTDIR)$(mandir)/man1/slogin.1
	gzip $(DESTDIR)$(mandir)/man1/*.1
	gzip $(DESTDIR)$(mandir)/man5/*.5
	gzip $(DESTDIR)$(mandir)/man8/*.8
	cd $(DESTDIR)$(mandir)/man1 && ln -s ssh.1.gz slogin.1.gz

cygwin-postinstall: move-config-files remove-empty-dir install-inetd-config install-doc install-scripts install-copy-id gzip-man-pages
	@echo "Cygwin specific configuration finished."

=== regress/unittests/bitmap/Makefile ===
#	$OpenBSD: Makefile,v 1.4 2017/12/21 00:41:22 djm Exp $

PROG=test_bitmap
SRCS=tests.c

# From usr.sbin/ssh
SRCS+=bitmap.c atomicio.c

REGRESS_TARGETS=run-regress-${PROG}

run-regress-${PROG}: ${PROG}
	env ${TEST_ENV} ./${PROG}

.include <bsd.regress.mk>

=== regress/unittests/sshbuf/Makefile ===
#	$OpenBSD: Makefile,v 1.10 2021/01/09 12:24:31 dtucker Exp $

#	$OpenBSD: Makefile,v 1.8 2020/01/26 00:09:50 djm Exp $

PROG=test_sshbuf
SRCS=tests.c
SRCS+=test_sshbuf.c
SRCS+=test_sshbuf_getput_basic.c
SRCS+=test_sshbuf_getput_crypto.c
SRCS+=test_sshbuf_misc.c
SRCS+=test_sshbuf_fuzz.c
SRCS+=test_sshbuf_getput_fuzz.c
SRCS+=test_sshbuf_fixed.c

# From usr.bin/ssh
SRCS+=sshbuf-getput-basic.c sshbuf-getput-crypto.c sshbuf-misc.c sshbuf.c
SRCS+=sshbuf-io.c atomicio.c misc.c xmalloc.c log.c fatal.c ssherr.c cleanup.c
SRCS+=match.c addr.c addrmatch.c

run-regress-${PROG}: ${PROG}
	env ${TEST_ENV} ./${PROG} ${UNITTEST_ARGS}

=== regress/unittests/sshkey/Makefile ===
#	$OpenBSD: Makefile,v 1.12 2023/01/15 23:35:10 djm Exp $

PROG=test_sshkey
SRCS=tests.c test_sshkey.c test_file.c test_fuzz.c common.c

# From usr.bin/ssh
SRCS+=sshbuf-getput-basic.c sshbuf-getput-crypto.c sshbuf-misc.c sshbuf.c
SRCS+=sshbuf-io.c atomicio.c sshkey.c authfile.c cipher.c log.c ssh-rsa.c
SRCS+=ssh-dss.c ssh-ecdsa.c ssh-ed25519.c mac.c umac.c umac128.c hmac.c misc.c
SRCS+=ssherr.c uidswap.c cleanup.c xmalloc.c match.c krl.c fatal.c
SRCS+=addr.c addrmatch.c bitmap.c
SRCS+=ed25519.c hash.c
SRCS+=cipher-chachapoly.c chacha.c poly1305.c ssh-ecdsa-sk.c ssh-sk.c
SRCS+=ssh-ed25519-sk.c sk-usbhid.c

SRCS+=digest-openssl.c
#SRCS+=digest-libc.c
SRCS+=utf8.c

REGRESS_TARGETS=run-regress-${PROG}

run-regress-${PROG}: ${PROG}
	env ${TEST_ENV} ./${PROG} ${UNITTEST_ARGS} -d ${.CURDIR}/testdata

.include <bsd.regress.mk>

=== debian/changelog ===
openssh (1:10.0p1-7progress8u1) horok; urgency=medium

  * Initial upload to horok.
  * Updating maintainer field.
  * Updating uploaders field.
  * Updating bugs field.
  * Updating vcs fields.
  * Enabling pam_access.so.
  * Disabling pam_motd.so.
  * Setting default RSA size in ssh-keygen to 4096.
  * Setting default ECDSA size in ssh-keygen to 521.
  * Removing small diffie-hellman moduli.
  * Updating options in ssh_config.
  * Including openssh-client configuration files for Progress Linux.
  * Setting CASignatureAlgorithms in ssh_config to ED25519.
  * Setting Ciphers in ssh_config to ChaCha20.
  * Setting HostbasedKeyTypes in ssh_config to ED25519.
  * Setting HostKeyAlgorithms in ssh_config to ED25519.
  * Setting KexAlgorithms in ssh_config to
    sntrup761x25519-sha512@openssh.com and Curve25519.
  * Setting MACs in ssh_config to UMAC and HMAC.
  * Setting PubkeyAcceptedKeyTypes in ssh_config to ED25519.
  * Setting IdentityFile in ssh_config to ED25519.
  * Setting openssh-server/permit-root-login to false.
  * Setting openssh-server/password-authentication to false.
  * Including openssh-server configuration files for Progress Linux.
  * Setting CASignatureAlgorithms in ssh_config to ED25519.
  * Setting Ciphers in sshd_config to ChaCha20.
  * Setting HostbasedAcceptedKeyTypes in sshd_config to ED25519.
  * Setting HostKeyAlgorithms in sshd_config to ED25519.
  * Setting KexAlgorithms in sshd_config to
    sntrup761x25519-sha512@openssh.com and Curve25519.
  * Setting MACs in sshd_config to UMAC and HMAC.
  * Setting PubkeyAcceptedKeyTypes in sshd_config to ED25519.
  * Setting HostCertificate in sshd_config to ED25519.
  * Setting HostKey in sshd_config to ED25519.
  * Setting AuthorizedKeysFile in sshd_config to
    /etc/ssh/authorized_keys/%u .ssh/authorized_keys.
  * Setting AllowAgentForwarding in sshd_config to no.
  * Setting DebianBanner in sshd_config to no.
  * Setting LoginGraceTime in sshd_config to 1m.
  * Setting MaxAuthTries in sshd_config to 3.
  * Adding patches from Colin Evrard <colin.evrard.134@gmail.com> for
    optional Multipath TCP support.
  * Refreshing mptcp patches.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 02 Aug 2025 05:20:05 +0200

openssh (1:10.0p1-7) unstable; urgency=medium

  * Make postinst logic for cleaning up the sshd diversion more robust.

 -- Colin Watson <cjwatson@debian.org>  Fri, 01 Aug 2025 16:02:27 +0100

openssh (1:10.0p1-6) unstable; urgency=medium

  * Temporarily divert /usr/sbin/sshd during upgrades from before
    1:9.8p1-1~, to avoid new connections failing between unpack and
    configure (closes: #1109742).

 -- Colin Watson <cjwatson@debian.org>  Mon, 28 Jul 2025 12:17:42 +0100

openssh (1:10.0p1-5) unstable; urgency=medium

  * Ensure that configure knows the path to passwd; fixes reproducibility of
    openssh-tests.

 -- Colin Watson <cjwatson@debian.org>  Fri, 09 May 2025 13:40:49 +0100

openssh (1:10.0p1-4) unstable; urgency=medium

  [ Daniel Kahn Gillmor ]
  * Add Requires=ssh-agent.socket to ssh-agent.service (closes: #1103522).

 -- Colin Watson <cjwatson@debian.org>  Fri, 09 May 2025 10:16:45 +0100

openssh (1:10.0p1-3) unstable; urgency=medium

  * Disable --with-linux-memlock-onfault again, since it causes
    RLIMIT_MEMLOCK to be exceeded with some combinations of PAM modules
    (closes: #1103418).

 -- Colin Watson <cjwatson@debian.org>  Wed, 07 May 2025 16:18:43 +0100

openssh (1:10.0p1-2) unstable; urgency=medium

  [ Colin Watson ]
  * Disable --with-linux-memlock-onfault on riscv64.
  * Build with wtmpdb (see #1102643).
  * Stop writing /var/log/btmp, since nothing reads it any more (closes:
    #1072184).
  * Restore some rdomain references in sshd_config(5) where they're
    supported on Linux, referring to ip-vrf(8) (closes: #1095686).

  [ Daniel Kahn Gillmor ]
  * Improve systemd user service socket activation (closes: #961311,
    #1039919, #1103037).

  [ Luca Boccassi ]
  * Switch from adduser to sysusers.d.
  * Add sshd-keygen service.

 -- Colin Watson <cjwatson@debian.org>  Tue, 15 Apr 2025 14:19:35 +0100

openssh (1:10.0p1-1) unstable; urgency=medium

  [ Luca Boccassi ]
  * Add COLORTERM NO_COLOR to SendEnv and AcceptEnv.

  [ Colin Watson ]
  * New upstream release:
    - This release removes support for the weak DSA signature algorithm.
    - scp(1), sftp(1): pass "ControlMaster no" to ssh when invoked by scp &
      sftp.
    - This release has the version number 10.0 and announces itself as
      "SSH-2.0-OpenSSH_10.0". Software that naively matches versions using
      patterns like "OpenSSH_1*" may be confused by this.
    - sshd(8): this release removes the code responsible for the user
      authentication phase of the protocol from the per-connection
      sshd-session binary to a new sshd-auth binary. Splitting this code
      into a separate binary ensures that the crucial pre-authentication
      attack surface has an entirely disjoint address space from the code
      used for the rest of the connection. It also yields a small runtime
      memory saving as the authentication code will be unloaded after the
      authentication phase completes. This change should be largely
      invisible to users, though some log messages may now come from
      "sshd-auth" instead of "sshd-session".
    - sshd(8): this release disables finite field (a.k.a modp)
      Diffie-Hellman key exchange in sshd by default. Specifically, this
      removes the "diffie-hellman-group*" and
      "diffie-hellman-group-exchange-*" methods from the default
      KEXAlgorithms list. The client is unchanged and continues to support
      these methods by default.
    - sshd(8): this release removes the implicit fallback to compiled-in
      groups for Diffie-Hellman Group Exchange KEX when the moduli file
      exists but does not contain moduli within the client-requested range.
      The fallback behaviour remains for the case where the moduli file does


=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: openssh
 Section: net
 Priority: standard
-Maintainer: Debian OpenSSH Maintainers <debian-ssh@lists.debian.org>
 Build-Depends:
  debhelper (>= 13.1~),
  debhelper-compat (= 13),
@@ -17,16 +16,22 @@
  libselinux1-dev [linux-any],
  libssl-dev (>= 1.1.1),
  libwrap0-dev | libwrap-dev,
+ libwtmpdb-dev,
  pkgconf,
  zlib1g-dev,
- lsb-release,
 Standards-Version: 4.6.2
-Uploaders:
+Maintainer: Progress Linux Maintainers <maintainers@lists.progress-linux.org>
+XSBC-Uploaders: Daniel Baumann <daniel.baumann@progress-linux.org>
+XSBC-Original-Maintainer: Debian OpenSSH Maintainers <debian-ssh@lists.debian.org>
+XSBC-Original-Uploaders:
  Colin Watson <cjwatson@debian.org>,
  Matthew Vernon <matthew@debian.org>,
+Bugs: mailto:maintainers@lists.progress-linux.org
 Homepage: https://www.openssh.com/
-Vcs-Git: https://salsa.debian.org/ssh-team/openssh.git
-Vcs-Browser: https://salsa.debian.org/ssh-team/openssh
+Vcs-Browser: https://git.progress-linux.org/horok/openssh
+Vcs-Git: https://git.progress-linux.org/horok/openssh
+XSBC-Original-Vcs-Browser: https://salsa.debian.org/ssh-team/openssh
+XSBC-Original-Vcs-Git: https://salsa.debian.org/ssh-team/openssh.git
 Rules-Requires-Root: no
 X-Style: black
 
@@ -34,6 +39,7 @@
 Architecture: any
 Depends:
  adduser,
+ init-system-helpers (>= 1.66~),
  passwd,
  ${misc:Depends},
  ${shlibs:Depends},
@@ -111,7 +117,6 @@
 Pre-Depends:
  ${misc:Pre-Depends},
 Depends:
- adduser,
  libpam-modules,
  libpam-runtime,
  lsb-base,

=== debian/rules ===
--- 
+++ 
@@ -74,6 +74,10 @@
 confflags += ossh_cv_cflag__fzero_call_used_regs_used=no
 endif
 
+# passwd isn't otherwise needed and may not be installed at build time.
+# Ensure that sshd knows its path.
+confflags += PATH_PASSWD_PROG=/usr/bin/passwd
+
 # Everything above here is common to the deb and udeb builds.
 confflags_udeb := $(confflags)
 
@@ -83,6 +87,7 @@
 confflags += --with-libedit
 confflags += --with-kerberos5=/usr
 confflags += --with-ssl-engine
+confflags += --with-wtmpdb
 ifeq ($(DEB_HOST_ARCH_OS),linux)
 confflags += --with-selinux
 confflags += --with-audit=linux
@@ -127,6 +132,13 @@
 	cd debian/build-udeb && ./config.status
 endif
 
+	# Nothing reads /var/log/btmp any more (see
+	# https://bugs.debian.org/1072184).
+	perl -pi -e 's,.*#define USE_BTMP .*,/* #undef USE_BTMP */,' debian/build-deb/config.h
+ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
+	perl -pi -e 's,.*#define USE_BTMP .*,/* #undef USE_BTMP */,' debian/build-udeb/config.h
+endif
+
 override_dh_auto_configure-indep:
 
 override_dh_auto_build-arch:
@@ -134,7 +146,7 @@
 	$(MAKE) -C debian/build-deb regress-prep
 	$(MAKE) -C debian/build-deb $(PARALLEL) regress-binaries regress-unit-binaries
 ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
-	$(MAKE) -C debian/build-udeb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass' ssh scp sftp sshd ssh-keygen sshd-session
+	$(MAKE) -C debian/build-udeb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass' ssh scp sftp sshd ssh-keygen sshd-auth sshd-session
 endif
 
 ifeq ($(filter pkg.openssh.nognome,$(DEB_BUILD_PROFILES)),)
@@ -172,15 +184,15 @@
 		debian/tmp/etc/ssh/ssh_config \
 		debian/tmp/etc/ssh/sshd_config
 
+	# Remove small Diffie-Hellman moduli
+	awk '$$5 >= 4095' debian/tmp/etc/ssh/moduli > debian/tmp/etc/ssh/moduli.tmp
+	mv -f debian/tmp/etc/ssh/moduli.tmp debian/tmp/etc/ssh/moduli
+
 	dh_install -Nopenssh-client-udeb -Nopenssh-server-udeb
 ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
 	dh_install -popenssh-client-udeb -popenssh-server-udeb \
 		--sourcedir=debian/build-udeb
 endif
-
-	# This can't be done using dh_link, because it's needed earlier by
-	# dh_installalternatives.
-	ln -sf ssh debian/openssh-client/usr/bin/slogin
 
 	rm -f debian/openssh-tests/usr/lib/openssh/regress/misc/sk-dummy/*.lo
 
@@ -194,14 +206,15 @@
 override_dh_installinit:
 	dh_installinit -R --name ssh
 
+# Can be dropped in compat level 14
+execute_after_dh_installinit:
+	dh_installsysusers
+
 override_dh_installsystemd:
-ifeq ($(shell lsb_release  -i -s),uos)
-	dh_installsystemd -popenssh-server --no-enable ssh.service
-else
 	dh_installsystemd -popenssh-server ssh.service
-endif
 	dh_installsystemd -popenssh-server --no-enable ssh.socket
 	dh_installsystemd -popenssh-server --no-start rescue-ssh.target
+	dh_installsystemd -popenssh-server sshd-keygen.service
 
 debian/openssh-server.sshd.pam: debian/openssh-server.sshd.pam.in
 ifeq ($(DEB_HOST_ARCH_OS),linux)
